%define mver 2.8.5
%define aver 1.3.22

%define contentdir /var/www

Summary: An SSL module for the Apache Web server.
Summary(de): SSL-Modul fuer den Apache-Webserver
Summary(fr): Un module SSL pour le serveur Web Apache
Name: mod_ssl
Version: %{mver}
Release: 2
Group: System Environment/Daemons
Source0: ftp://ftp.modssl.org/source/mod_ssl-%{mver}-%{aver}.tar.bz2
Source1: SSL-Certificate-Creation
Source2: mod_ssl.logrotate
Source3: sxnet.html
Patch0: mod_ssl-2.6.4-tty.patch
Patch1: mod_ssl-2.8.4-sdbm.patch
Patch2: mod_ssl-2.8.4-openssl.patch
License: Apache Software License
Vendor: Ralf S. Engelschall <rse@engelschall.com>
URL: http://www.modssl.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: apache = %{aver}, openssl, dev
BuildPreReq: apache-devel = %{aver}, eapi = %{version}, mm-devel

%description
The mod_ssl project provides strong cryptography for the Apache 1.3 webserver 
via the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1) 
protocols by the help of the Open Source SSL/TLS toolkit OpenSSL, which is 
based on SSLeay from Eric A. Young and Tim J. Hudson. 

The mod_ssl package was created in April 1998 by Ralf S. Engelschall and was 
originally derived from software developed by Ben Laurie for use in the 
Apache-SSL HTTP server project. The mod_ssl package is licensed under a 
BSD-style licence, which basically means that you are free to get and use it 
for commercial and non-commercial purposes. 

%description -l de
Das mod_ssl-Projekt stellt kryptographie fr den Apache 1.3-Webserver ber
Secure Sockets Layer (SSL v2/v3) und Transport Layer Security (TLS
v1)-Protokolle zur Verfgung. Dazu wird das Open Source SSL/TLS-Toolkit
OpenSSL, das auf SSLeay basiert, verwendet.

%description -l fr
Le projet mod_ssl fournit de la forte cryptographie pour le serveur web
Apache 1.3 via les protocoles Secure Sockets Layer (SSL v2/v3) et Transport Layer
Security (TLS v1) avec l'aide du kit d'outils Open Source SSL/TLS, OpenSSL,
base sur SSLeay d'Eric A. Young et Tim J. Hudson.

%ifnarch i586 i686
%package doc
Summary: The manual of mod_ssl package.
Group: Development/Libraries

%description doc
The manual of mod_ssl package.
%endif

%package sxnet
Summary: Strong Extranet module for mod_ssl and apache
Summary(fr): Module d'Extranet Fort pour Apache et mod_ssl
Group: System Environment/Daemons
Prereq: apache = %{aver}, openssl

%description sxnet
The Strong Extranet allows you to use digital certificates to authenticate
users on your web server. Typically, your users enroll in your Strong 
Extranet, under your control, through the Thawte Personal Cert System.  

%description -l fr
L'Extranet Fort vous permet d'utiliser des certificats numeriques pour
authentifier les usagers sur votre serveur web. Typiquement, vos usagers
s'enrolent dans votre Extranet Fort, sous votre controle, a travers le
Thawte Personal Cert System.

%ifnarch i586 i686
%package sxnet-doc
Summary: The manual of mod_ssl-sxnet package.
Group: Development/Libraries

%description sxnet-doc
The manual of mod_ssl-sxnet package.
%endif

%prep
%setup -q -n %{name}-%{mver}-%{aver}
%patch0 -p2 -b .tty
%patch1 -p1 -b .sdbm
%patch2 -p1 -b .openssl

%build
CFLAGS="$RPM_OPT_FLAGS -fPIC" ; export CFLAGS

SSL_COMPAT=yes; export SSL_COMPAT
SSL_EXPERIMENTAL=yes ; export SSL_EXPERIMENTAL
# The --force below keeps configure from failing when the httpd binary
# is not present, and changes nothing else.
%configure --with-apxs=%{_sbindir}/apxs --with-mm=SYSTEM --force
make

cd pkg.contrib
tar xvf sxnet.tar
cd sxnet
%{_sbindir}/apxs -I/usr/include/openssl/ -L/usr/lib -l ssl -l crypto -c mod_sxnet.c

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT`%{_sbindir}/apxs -q LIBEXECDIR`
install -m755 pkg.sslmod/libssl.so $RPM_BUILD_ROOT`%{_sbindir}/apxs -q LIBEXECDIR`
install -m 755 pkg.contrib/sxnet/mod_sxnet.so $RPM_BUILD_ROOT`%{_sbindir}/apxs -q LIBEXECDIR`

# install config information
for suffix in crl crt csr key prm ; do
	mkdir -p $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}
	install -m644 pkg.sslcfg/*.${suffix} $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}
	rm -f $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}/server.*
done
chmod 600 $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.*/*.key

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/mod_ssl.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/mod_ssl

# install docs
mkdir -p $RPM_BUILD_ROOT%{contentdir}/html/manual/mod/mod_ssl/
install -m644 pkg.ssldoc/*.{html,gif,jpg} \
	$RPM_BUILD_ROOT%{contentdir}/html/manual/mod/mod_ssl/

mkdir -p $RPM_BUILD_ROOT%{contentdir}/html/manual/mod/other
install -m 644 $RPM_SOURCE_DIR/sxnet.html $RPM_BUILD_ROOT%{contentdir}/html/manual/mod/other/mod_sxnet.html

# point to the right makefile.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf
ln -s ../../../usr/share/ssl/certs/Makefile $RPM_BUILD_ROOT/etc/httpd/conf

find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|%{__perl}|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|%{__perl}|g;"

# create a prototype session cache
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/cache
touch $RPM_BUILD_ROOT%{_localstatedir}/cache/ssl_gcache_data.{dir,pag,sem}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
umask 077

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.key/server.key ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{_sysconfdir}/httpd/conf/ssl.key/server.key 2> /dev/null
fi

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.crt/server.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/httpd/conf/ssl.key/server.key -x509 -days 365 -out %{_sysconfdir}/httpd/conf/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
fi

%files
%defattr(-,root,root)
%doc $RPM_SOURCE_DIR/SSL-Certificate-Creation README* LICENSE NEWS CHANGES CREDITS
%{_libdir}/apache/libssl.so
%{_sysconfdir}/httpd/conf/Makefile
%attr(0700,root,root) %dir %{_sysconfdir}/httpd/conf/ssl.*
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.sem
%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/conf/ssl.*/*

%files sxnet
%defattr(-,root,root)
%{_libdir}/apache/mod_sxnet.so

%ifnarch i586 i686
%files doc
%defattr(-,root,root)
%{contentdir}/html/manual/mod/mod_ssl/

%files sxnet-doc
%defattr(-,root,root)
%{contentdir}/html/manual/mod/other/mod_sxnet.html
%endif

%changelog
* Sat Oct 27 2001 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.8.5-1.3.22
- merged stuff from RedHat's mod_ssl-2.8.4-9 package (some patches plus
  see below)

* Thu Jul 19 2001 Nalin Dahyabhai <nalin@redhat.com>
- use --force when configuring so that we don't error out -- the apxs
  script still works

* Wed Jul 18 2001 Nalin Dahyabhai <nalin@redhat.com>
- add a mod_ssl.logrotate configuration file to the package

* Wed Mar  7 2001 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.8.1-1.3.19

* Mon Oct 16 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.7.1-1.3.14
- "requires" changed to "prereq"
- "BuildPreReq mm" changed to "BuildPreReq mm-devel"
- added requires to sxnet package too

* Tue Aug 22 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.6.6-1.3.12
- added %%dir %%{crtsdir} and %%dir %%{keysdir} to %%files
- pkg.contrib/*.sh moved from /usr/local/ssl/mod_ssl to %%{_datadir}/mod_ssl
- documentation moved from %%{contentdir}/html/ssl-doc to
  %%{contentdir}/html/manual/mod/other/mod_ssl and made as separate package
- sxnet documentation moved from %%{contentdir}/html/sxnet/index.html to
  %%{contentdir}/html/manual/mod/other/mod_sxnet.html and made as separate
  package
- %%config(noreplace) used for server.key and server.crt
- do not make doc packages for i586 and i686 architectures

* Tue Jul 18 2000 Peter Hanecak <hanecak@megaloman.sk>
- synchronized with apache-1.3.12-2 (%%{contentdir} is /var/www, ...)
- BuildPreReq apache-devel (because of apxs)
- more info used from apxs

* Thu Jul  6 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.6.5-1.3.12
- %%{_tmppath} used

* Fri May 26 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.6.4-1.3.12
- small spec tweaking

* Thu Mar  9 2000 Michael Tokarev <mjt@tls.msk.ru>
- modified .spec file to simplify installation on non-default http home dir
  (RedHat uses /home/httpd, variants are /var/httpd etc)
- removed implicit dependance on mm library (if used as shared, it
  will be found by rpm); added it to BuildPreReq section
- changed PreReq to BuildPreReq (so that it will not depend on apache-devel)
- added apache-devel to BuildPreReq
- added implicit version of required apache (maybe wrong?)

* Fri Mar  3 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.6.2-1.3.12
- %post changed so it does not include "Include conf/httpd.conf.ssl"
  into http.conf if it is alredy present (even when commented out)

* Wed Mar  1 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.6.1-1.3.12
- requires mm, requires apache-devel for building
- 'apxs' replaced with '/usr/sbin/apxs'
- do not automaticaly restart webserver (%post, %postun)

* Sat Feb 26 2000 Peter Hanecak <hanecak@megaloman.sk>
- update ot 2.6.0-1.3.12
- added URL

* Wed Feb  9 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 2.5.0-1.3.11
- some little spec changes (vendor, defattr, ...)
- mm library used

* Sat Jun 05 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- moved documentation in html
- rebuilt for the new optimized apache

* Sun May 30 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 2.3.1
- add fr locale
- added sxnet (Secure ExtraNet) package from Thawte

* Sun May 23 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- handle RPM_OPT_FLAGS
- add de locale
- don't require openssl-devel
